<?php if (!defined('PmWiki')) exit();
/***********************************************************************
**  skin.php
**  Copyright 2016 Petko Yotov www.pmwiki.org/petko
**  
**  This file is part of PmWiki; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published
**  by the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.  See pmwiki.php for full details.
***********************************************************************/

$RecipeInfo['2016Skin']['version'] = '20160823';

global $HTMLStylesFmt, $SkinElementsPages, $DefaultSkinElements, $TableCellAlignFmt, 
  $SearchBoxInputType;

# Disable inline styles injected by the PmWiki core (we provide these styles)
$styles = explode(' ', 'pmwiki rtl-ltr wikistyles markup simuledit diff urlapprove vardoc');
foreach($styles as $style) $HTMLStylesFmt[$style] = '';

# CSS alignment for table cells (valid HTML5)
$TableCellAlignFmt = " class='%s'";

# For (:searchbox:), valid semantic HTML5
$SearchBoxInputType = "search";

# remove deprecated "name=" parameter from anchor tags
Markup_e('[[#','<[[','/(?>\\[\\[#([A-Za-z][-.:\\w]*))\\]\\]/',
  "Keep(TrackAnchors(\$m[1]) ? '' : \"<a id='{\$m[1]}'></a>\", 'L')");

# Allow skin header and footer to be written 
# in a wiki page, and use defaults otherwise
SDV($SkinElementsPages, array('{$Group}.SkinElements', '{$SiteGroup}.SkinElements'));
SDVA($DefaultSkinElements, array(
  'skinheader' => '<span id="wikilogo"><a href="{$ScriptUrl}"><img src="$PageLogoUrl" alt="$WikiTitle"/></a></span>
    <form id="wikihead-searchform" action="{$ScriptUrl}" method="get">
      <span class="headnav" id="wikihead-recent-changes-link">
        <a href="{$ScriptUrl}/$[{$Group}/RecentChanges]" accesskey="$[ak_recentchanges]">$[Recent Changes]</a> - 
      </span>
      <span id="wikihead-searchlink"><a href="{$ScriptUrl}/$[{$SiteGroup}/Search]">$[Search]</a>:</span>
      <input type="hidden" name="n" value="{$FullName}" />
      <input type="hidden" name="action" value="search" />
      <input id="wikihead-searchquery" type="search" name="q" value="" class="inputbox searchbox" placeholder="$[Search]" />
      <input id="wikihead-searchsubmitbtn" type="submit" class="inputbutton searchbutton" value="$[Go]" />
    </form>',
  'skinfooter' => '<div id="wikifoot-links" class="footnav">
      <a rel="nofollow" href="{$PageUrl}?action=edit">$[Edit]</a> -
      <a rel="nofollow" href="{$PageUrl}?action=diff">$[History]</a> -
      <a rel="nofollow" href="{$PageUrl}?action=print" target="_blank">$[Print]</a> -
      <a href="{$ScriptUrl}/$[{$Group}/RecentChanges]">$[Recent Changes]</a> -
      <a href="{$ScriptUrl}/$[{$SiteGroup}/Search]">$[Search]</a>
    </div>
    <div id="wikifoot-lastmod" class="lastmod">$[Page last modified on {$LastModified}]</div>',
));

# This function prints a skin element which is written 
# inside a [[#header]]...[[#headerend]] section in Site.SkinElements
function SkinElement($pagename, $section) {
  global $SkinElementsPages, $DefaultSkinElements;
  foreach($SkinElementsPages as $p) {
    $pn = FmtPageName($p, $pagename);
    $elm = RetrieveAuthSection($pn, "#$section#{$section}end");
    if(!$elm) continue;
    
    echo MarkupToHTML($pagename, Qualify($pn, $elm));
    return;
  }
  if(@$DefaultSkinElements[$section])
    echo FmtPageName($DefaultSkinElements[$section], $pagename);
}

